define(
"dojo/nls/id/colors", ({
// local representation of all CSS3 named colors, companion to dojo.colors.  To be used where descriptive information
// is required for each color, such as a palette widget, and not for specifying color programatically.
	//Note: due to the SVG 1.0 spec additions, some of these are alternate spellings for the same color (e.g. gray / grey).
	//TODO: should we be using unique rgb values as keys instead and avoid these duplicates, or rely on the caller to do the reverse mapping?
	aliceblue: "alice blue",
	antiquewhite: "antique white",
	aqua: "aqua",
	aquamarine: "biru laut",
	azure: "biru langit",
	beige: "krem",
	bisque: "bisque",
	black: "hitam",
	blanchedalmond: "almond pucat",
	blue: "biru",
	blueviolet: "biru-ungu",
	brown: "coklat",
	burlywood: "burlywood",
	cadetblue: "cadet blue",
	chartreuse: "chartreuse",
	chocolate: "chocolate",
	coral: "coral",
	cornflowerblue: "cornflower blue",
	cornsilk: "cornsilk",
	crimson: "crimson",
	cyan: "cyan",
	darkblue: "biru tua",
	darkcyan: "dark cyan",
	darkgoldenrod: "dark goldenrod",
	darkgray: "abu-abu tua",
	darkgreen: "hijau tua",
	darkgrey: "abu-abu tua", // same as darkgray
	darkkhaki: "dark khaki",
	darkmagenta: "magenta tua",
	darkolivegreen: "olive hijau tua",
	darkorange: "jingga tua",
	darkorchid: "dark orchid",
	darkred: "merah tua",
	darksalmon: "dark salmon",
	darkseagreen: "hijau laut tua",
	darkslateblue: "biru batu tua",
	darkslategray: "abu-abu batu tua",
	darkslategrey: "abu-abu batu tua", // same as darkslategray
	darkturquoise: "turquoise tua",
	darkviolet: "lembayung tua",
	deeppink: "merah muda dalam",
	deepskyblue: "hijau langit dalam",
	dimgray: "abu-abu temaram",
	dimgrey: "abu-abu temaram", // same as dimgray
	dodgerblue: "dodger blue",
	firebrick: "fire brick",
	floralwhite: "putih bunga",
	forestgreen: "hijau hutan",
	fuchsia: "fuchsia",
	gainsboro: "gainsboro",
	ghostwhite: "ghost white",
	gold: "emas",
	goldenrod: "goldenrod",
	gray: "abu-abu",
	green: "hijau",
	greenyellow: "hijau-kuning",
	grey: "abu-abu", // same as gray
	honeydew: "hijau melon",
	hotpink: "hot pink",
	indianred: "merah indian",
	indigo: "nila",
	ivory: "ivory",
	khaki: "khaki",
	lavender: "lembayung muda",
	lavenderblush: "lembayung muda kemerahan",
	lawngreen: "rumput hijau",
	lemonchiffon: "lemon chiffon",
	lightblue: "biru muda",
	lightcoral: "coral muda",
	lightcyan: "light cyan",
	lightgoldenrodyellow: "kuning goldenrod muda",
	lightgray: "abu-abu muda",
	lightgreen: "hijau muda",
	lightgrey: "abu-abu muda", // same as lightgray
	lightpink: "merah jambu muda",
	lightsalmon: "light salmon",
	lightseagreen: "hijau laut muda",
	lightskyblue: "hijau langit muda",
	lightslategray: "au-abu batu tua",
	lightslategrey: "abu-abu batu tua", // same as lightslategray
	lightsteelblue: "biru baja muda",
	lightyellow: "kuning muda",
	lime: "limau",
	limegreen: "hijau limau",
	linen: "linen",
	magenta: "magenta",
	maroon: "maroon",
	mediumaquamarine: "medium aquamarine",
	mediumblue: "biru medium",
	mediumorchid: "medium orchid",
	mediumpurple: "ungu medium",
	mediumseagreen: "hijau laut medium",
	mediumslateblue: "biru batu medium",
	mediumspringgreen: "medium spring green",
	mediumturquoise: "medium turquoise",
	mediumvioletred: "ungu-merah medium",
	midnightblue: "midnight blue",
	mintcream: "mint cream",
	mistyrose: "misty rose",
	moccasin: "moccasin",
	navajowhite: "navajo white",
	navy: "navy",
	oldlace: "old lace",
	olive: "olive",
	olivedrab: "olive drab",
	orange: "jingga",
	orangered: "merah jingga",
	orchid: "orchid",
	palegoldenrod: "goldenrod pucat",
	palegreen: "hijau pucat",
	paleturquoise: "turquoise pucat",
	palevioletred: "ungu-marah pucat",
	papayawhip: "papaya whip",
	peachpuff: "peach puff",
	peru: "peru",
	pink: "merah jambu",
	plum: "plum",
	powderblue: "powder blue",
	purple: "ungu",
	red: "merah",
	rosybrown: "rosy brown",
	royalblue: "royal blue",
	saddlebrown: "saddle brown",
	salmon: "salmon",
	sandybrown: "sandy brown",
	seagreen: "hijau laut",
	seashell: "seashell",
	sienna: "sienna",
	silver: "perak",
	skyblue: "biru langit",
	slateblue: "biru batu",
	slategray: "abu-abu batu",
	slategrey: "abu-abu batu", // same as slategray
	snow: "snow",
	springgreen: "spring green",
	steelblue: "biru baja",
	tan: "tan",
	teal: "teal",
	thistle: "thistle",
	tomato: "tomat",
	transparent: "transparan",
	turquoise: "biru hijau",
	violet: "lembayung",
	wheat: "wheat",
	white: "putih",
	whitesmoke: "white smoke",
	yellow: "kuning",
	yellowgreen: "kuning hijau"
})
);

