define(
"dojox/editor/plugins/nls/pt-pt/latinEntities", ({
	/* These are already handled in the default RTE
	amp:"ampersand",lt:"less-than sign",
	gt:"greater-than sign",
	nbsp:"no-break space\nnon-breaking space",
	quot:"quote",
	*/
	iexcl:"ponto de exclamação invertido",
	cent:"símbolo de cêntimo",
	pound:"símbolo de libra",
	curren:"símbolo monetário",
	yen:"símbolo do iene\nsímbolo do yuan",
	brvbar:"barra quebrada\nbarra vertical quebrada",
	sect:"símbolo de secção",
	uml:"trema\ntrema de espaçamento",
	copy:"símbolo de direitos de autor",
	ordf:"indicador ordinal feminino",
	laquo:"aspas esquerdas em ângulo\naspas esquerdas",
	not:"sinal de negação",
	shy:"hífen de sílaba\nhífen discricionário",
	reg:"símbolo de marca registada\nsímbolo de marca comercial registada",
	macr:"macro\nmacro de espaçamento\nlinha sobreposta\nbarra superior de APL",
	deg:"sinal de graus",
	plusmn:"sinal de adição-subtracção\nsinal de adição ou subtracção",
	sup2:"superior à linha dois\nsuperior à linha do segundo algarismo\nao quadrado",
	sup3:"superior à linha três\nsuperior à linha do terceiro algarismo\nao cubo",
	acute:"acento agudo\nacento agudo de espaço",
	micro:"sinal de micro",
	para:"sinal de parágrafo\nsímbolo de parágrafo",
	middot:"ponto centrado\nvírgula Georgiana\nponto centrado Grego",
	cedil:"cedilha\ncedilha de espaçamento",
	sup1:"superior à linha um\nsuperior à linha do primeiro algarismo",
	ordm:"indicador ordinal masculino",
	raquo:"aspas direitas em ângulo\naspas direitas",
	frac14:"fracção comum - um quarto\nfracção - um quarto",
	frac12:"fracção comum - um meio\nfracção - um meio",
	frac34:"fracção comum - três quartos\nfracção - três quartos",
	iquest:"ponto de interrogação invertido",
	Agrave:"Latim - Letra maiúscula A com acento grave\nLatim - Letra maiúscula A grave",
	Aacute:"Latim - Letra maiúscula A com acento agudo",
	Acirc:"Latim - Letra maiúscula A com acento circunflexo",
	Atilde:"Latim - Letra maiúscula A com til",
	Auml:"Latim - Letra maiúscula A com trema",
	Aring:"Latim - Letra maiúscula A com círculo por cima\nLatim - Letra maiúscula A com círculo",
	AElig:"Latim - Letras maiúsculas AE\nLatim - Letras maiúsculas ligadas AE",
	Ccedil:"Latim - Letra maiúscula C com cedilha",
	Egrave:"Latim - Letra maiúscula E com acento grave",
	Eacute:"Latim - Letra maiúscula E com acento agudo",
	Ecirc:"Latim - Letra maiúscula E com acento circunflexo",
	Euml:"Latim - Letra maiúscula E com trema",
	Igrave:"Latim - Letra maiúscula I com acento grave",
	Iacute:"Latim - Letra maiúscula I com acento agudo",
	Icirc:"Latim - Letra maiúscula I com acento circunflexo",
	Iuml:"Latim - Letra maiúscula I com trema",
	ETH:"Latim - Letra maiúscula islandesa ETH",
	Ntilde:"Latim - Letra maiúscula N com til",
	Ograve:"Latim - Letra maiúscula O com acento grave",
	Oacute:"Latim - Letra maiúscula O com acento agudo",
	Ocirc:"Latim - Letra maiúscula O com acento circunflexo",
	Otilde:"Latim - Letra maiúscula O com til",
	Ouml:"Latim - Letra maiúscula O com trema",
	times:"sinal de multiplicação",
	Oslash:"Latim - Letra maiúscula O cortada por um traço\nLatim - Letra maiúscula O cortada",
	Ugrave:"Latim - Letra maiúscula U com acento grave",
	Uacute:"Latim - Letra maiúscula U com acento agudo",
	Ucirc:"Latim - Letra maiúscula U com acento circunflexo",
	Uuml:"Latim - Letra maiúscula U com trema",
	Yacute:"Latim - Letra maiúscula Y com acento agudo",
	THORN:"Latim - Letra maiúscula islandesa THORN",
	szlig:"Latim - Letra minúscula beta\nS tzét alemão",
	agrave:"Latim - Letra minúscula a com acento grave\nLatim - Letra minúscula a grave",
	aacute:"Latim - Letra minúscula a com acento agudo",
	acirc:"Latim - Letra minúscula a com acento circunflexo",
	atilde:"Latim - Letra minúscula a com til",
	auml:"Latim - Letra minúscula a com trema",
	aring:"Latim - Letra minúscula a com círculo por cima\nLatim - Letra minúscula a com círculo",
	aelig:"Latim - Letras minúsculas ae\nLatim - Letras minúsculas ligadas ae",
	ccedil:"Latim - Letra minúscula c com cedilha",
	egrave:"Latim - Letra minúscula e com acento grave",
	eacute:"Latim - Letra minúscula e com acento agudo",
	ecirc:"Latim - Letra minúscula e com acento circunflexo",
	euml:"Latim - Letra minúscula e com trema",
	igrave:"Latim - Letra minúscula i com acento grave",
	iacute:"Latim - Letra minúscula i com acento agudo",
	icirc:"Latim - Letra minúscula i com acento circunflexo",
	iuml:"Latim - Letra minúscula i com trema",
	eth:"Latim - Letra minúscula islandesa eth",
	ntilde:"Latim - Letra minúscula n com til",
	ograve:"Latim - Letra minúscula o com acento grave",
	oacute:"Latim - Letra minúscula o com acento agudo",
	ocirc:"Latim - Letra minúscula o com acento circunflexo",
	otilde:"Latim - Letra minúscula o com til",
	ouml:"Latim - Letra minúscula o com trema",
	divide:"sinal de divisão",
	oslash:"Latim - Letra minúscula o cortada por um traço\nLatim - Letra minúscula o cortada",
	ugrave:"Latim - Letra minúscula u com acento grave",
	uacute:"Latim - Letra minúscula u com acento agudo",
	ucirc:"Latim - Letra minúscula u com acento circunflexo",
	uuml:"Latim - Letra minúscula u com trema",
	yacute:"Latim - Letra minúscula y com acento agudo",
	thorn:"Latim - Letra minúscula islandesa thorn",
	yuml:"Latim - Letra minúscula y com trema",
// Greek Characters and Symbols
	fnof:"Latim - Letra minúscula f com gancho\nfunção\nflorim",
	Alpha:"Grego - Letra maiúscula alfa",
	Beta:"Grego - Letra maiúscula beta",
	Gamma:"Grego - Letra maiúscula gama",
	Delta:"Grego - Letra maiúscula delta",
	Epsilon:"Grego - Letra maiúscula épsilon",
	Zeta:"Grego - Letra maiúscula zeta",
	Eta:"Grego - Letra maiúscula eta",
	Theta:"Grego - Letra maiúscula teta",
	Iota:"Grego - Letra maiúscula iota",
	Kappa:"Grego - Letra maiúscula capa",
	Lambda:"Grego - Letra maiúscula lambda",
	Mu:"Grego - Letra maiúscula mi",
	Nu:"Grego - Letra maiúscula ni",
	Xi:"Grego - Letra maiúscula csi",
	Omicron:"Grego - Letra maiúscula ómicron",
	Pi:"Grego - Letra maiúscula pi",
	Rho:"Grego - Letra maiúscula ró",
	Sigma:"Grego - Letra maiúscula sigma",
	Tau:"Grego - Letra maiúscula tau",
	Upsilon:"Grego - Letra maiúscula ípsilon",
	Phi:"Grego - Letra maiúscula fi",
	Chi:"Grego - Letra maiúscula qui",
	Psi:"Grego - Letra maiúscula psi",
	Omega:"Grego - Letra maiúscula ómega",
	alpha:"Grego - Letra minúscula alfa",
	beta:"Grego - Letra minúscula beta",
	gamma:"Grego - Letra minúscula gama",
	delta:"Grego - Letra minúscula delta",
	epsilon:"Grego - Letra minúscula épsilon",
	zeta:"Grego - Letra minúscula zeta",
	eta:"Grego - Letra minúscula eta",
	theta:"Grego - Letra minúscula teta",
	iota:"Grego - Letra minúscula iota",
	kappa:"Grego - Letra minúscula capa",
	lambda:"Grego - Letra minúscula lambda",
	mu:"Grego - Letra minúscula mi",
	nu:"Grego - Letra minúscula ni",
	xi:"Grego - Letra minúscula csi",
	omicron:"	Grego - Letra minúscula ómicron",
	pi:"Grego - Letra minúscula pi",
	rho:"Grego - Letra minúscula ró",
	sigmaf:"	Grego - Letra minúscula sigma final",
	sigma:"Grego - Letra minúscula sigma",
	tau:"Grego - Letra minúscula tau",
	upsilon:"Grego - Letra minúscula ípsilon",
	phi:"Grego - Letra minúscula fi",
	chi:"Grego - Letra minúscula qui",
	psi:"	Grego - Letra minúscula psi",
	omega:"Grego - Letra minúscula ómega",
	thetasym:"Grego - Símbolo da letra minúscula teta",
	upsih:"Grego - Ípsilon com símbolo do gancho",
	piv:"Grego - Símbolo pi",
	bull:"marca\ncírculo pequeno preto",
	hellip:"reticências horizontais\ntrês pontos de seguimento",
	prime:"número primo\nminutos\npés",
	Prime:"número primo duplo\nsegundos\npolegadas",
	oline:"linha sobreposta\nlinha sobreposta de espaçamento",
	frasl:"barra de fracção",
	weierp:"letra maiúscula P cursiva\nconjunto de partes\nletra p Weierstrass",
	image:"letra maiúscula I carregada\nparte imaginária",
	real:"letra maiúscula R carregada\nsímbolo da parte real",
	trade:"símbolo de marca comercial",
	alefsym:"símbolo de elif\nprimeiro transfinito cardinal",
	larr:"seta para a esquerda",
	uarr:"seta para cima",
	rarr:"seta para a direita",
	darr:"seta para baixo",
	harr:"seta para a esquerda e para a direita",
	crarr:"seta para baixo em ângulo recto para a esquerda\nsímbolo de retorno",
	lArr:"seta dupla para a esquerda",
	uArr:"seta dupla para cima",
	rArr:"seta dupla para a direita",
	dArr:"seta dupla para baixo",
	hArr:"Seta dupla para a esquerda e para a direita",
	forall:"para todos",
	part:"diferencial parcial",
	exist:"existe",
	empty:"conjunto vazio\nconjunto nulo\ndiâmetro",
	nabla:"nabla\ndiferença retroactiva",
	isin:"pertence a",
	notin:"não pertence a",
	ni:"contém como membro",
	prod:"produto n-ário\nsinal de produto",
	sum:"somatório n-ário",
	minus:"sinal de subtracção",
	lowast:"operador asterisco",
	radic:"raiz quadrada\nsinal de radical",
	prop:"proporcional a",
	infin:"infinito",
	ang:"ângulo",
	and:"E lógico\ncunha",
	or:"OU lógico\nvee",
	cap:"intersecção\ncap",
	cup:"união\ncup","int":"integral",
	there4:"para isso",
	sim:"operador de til\nvaria com\nsemelhante a",
	cong:"aproximadamente igual a",
	asymp:"quase igual a\nassimptótico a",
	ne:"não igual a",
	equiv:"idêntico a",
	le:"menor ou igual a",
	ge:"maior ou igual a",
	sub:"está contido",
	sup:"contém",
	nsub:"não está contido em",
	sube:"está contido ou igual a",
	supe:"contém ou igual a",
	oplus:"adição dentro de um círculo\nsoma directa",
	otimes:"multiplicação dentro de um círculo\nproduto vectorial",
	perp:"tacha em cima\nortogonal a\nperpendicular",
	sdot:"operador de ponto",
	lceil:"tecto à esquerda\nbarra superior APL",
	rceil:"limite superior à direita",
	lfloor:"chão à esquerda\nbarra inferior APL",
	rfloor:"limite inferior à direita",
	lang:"parêntese esquerdo em ângulo",
	rang:"parêntese direito em ângulo",
	loz:"losango",
	spades:"naipe preto de espadas",
	clubs:"naipe preto de paus\ntrevo",
	hearts:"naipe preto de copas\ncoração",
	diams:"naipe preto de ouros",
	OElig:"Latim - Letras maiúsculas ligadas OE",
	oelig:"Latim - Letras minúsculas ligadas oe",
	Scaron:"Latim - Letra maiúscula S com cáron",
	scaron:"Latim - Letra minúscula s com cáron",
	Yuml:"Latim - Letra maiúscula Y com trema",
	circ:"modificadores - acento circunflexo",
	tilde:"til pequeno",
	ensp:"espaço simples",
	emsp:"espaço duplo",
	thinsp:"espaço fino",
	zwnj:"não separador de largura nula",
	zwj:"separador de largura nula",
	lrm:"marca da esquerda para a direita",
	rlm:"marca da direita para a esquerda",
	ndash:"traço",
	mdash:"travessão",
	lsquo:"plica esquerda",
	rsquo:"plica direita",
	sbquo:"plica curva inferior",
	ldquo:"aspas esquerdas",
	rdquo:"aspas direitas",
	bdquo:"aspas curvas inferiores",
	dagger:"óbelo",
	Dagger:"óbelo duplo",
	permil:"sinal de por mil",
	lsaquo:"plica esquerda em ângulo",
	rsaquo:"plica direita em ângulo",
	euro:"símbolo do euro"
})
);
